#include "Helix.h"
#include "IOMap.h"

const double kHelixSpeed = .90;

Helix::Helix() : desiredSpeed(0), 
                helixMotor(ThunderSparkMax::create(ThunderSparkMax::MotorID::StorageAgitator))
{
    
    helixMotor->SetOpenLoopRampRate(0.5); 
    helixMotor->SetIdleMode(ThunderSparkMax::COAST);
}

void Helix::Process(){
    helixMotor->Set(desiredSpeed);
}

void Helix::Debug(Feedback *feedback){
    feedback->sendDouble("Helix","Speed", desiredSpeed);
}
// Start the helix motor
void Helix::SetOn(){
    desiredSpeed = kHelixSpeed;
}
/*void Helix::SetSlowOn(){
    desiredSpeed = .2;//if we need to keep the motor moving to keep the ball up in the helix 
}*/
// Stop the helix motor
void Helix::SetOff(){
    desiredSpeed = 0;

}
void Helix::SetReverse(){
    desiredSpeed = -kHelixSpeed;
}
// maybe add functions for telling if the helix is jammed based on motor voltage