#pragma once

#include <frc/Joystick.h>
#include "frc/XboxController.h"

#include "Drive.h"
#include "GamePiece.h"
#include "Hang.h"
#include "ControlPanel.h"
#include "Feedback.h"
#include "Limelight.h"

class Controls {
    public:
    Controls(Drive* drive, GamePiece* gamePiece, Hang* hang, ControlPanel* controlPanel);
    void process();
    void debug(Feedback* feedback);
    
    private:
    frc::Joystick controllerDriver{0};
    frc::Joystick controllerAux{1};
    frc::Joystick controllerAux2{2};

    Drive* drive;
    GamePiece* gamePiece;
    Hang* hang;
    ControlPanel* controlPanel;
    Limelight* limelight;

    void processDriver();
    void processAux();
    void brokenSensor();
    bool isTankMode = false; // true = tank, false = arcade
    bool wasDriveModeToggled = false;
    double desiredShooterSpeed = 0;
    frc::Timer turboHeld{};

    /*
    enum LimelightState{
        TURNING,
        DRIVING,
        AIMED
    };
    LimelightState limelightState;*/

    bool viewingLimelight = false;

    double getPower(double speed, bool turbo, bool slow);
};