/*----------------------------------------------------------------------------*/
/* Copyright (c) 2018 FIRST. All Rights Reserved.                             */
/* Open Source Software - may be modified and shared by FRC teams. The code   */
/* must be accompanied by the FIRST BSD license file in the root directory of */
/* the project.                                                               */
/*----------------------------------------------------------------------------*/

#pragma once
#include "ControlPanel.h"
#include "Hang.h"
#include "GamePiece.h"
#include "Drive.h"
#include "Controls.h"
#include "Feedback.h"
#include "Lights.h"
#include "Autonomous.h"
#include "Log.h"
#include <frc/TimedRobot.h>
#include <frc/smartdashboard/SmartDashboard.h>
#include "cameraserver/CameraServer.h"
#include <frc/Timer.h>

class Robot : public frc::TimedRobot {
 public:
  void RobotInit() override;

  void AutonomousInit() override;
  void AutonomousPeriodic() override;

  void TeleopInit() override;
  void TeleopPeriodic() override;

  void TestInit() override;
  void TestPeriodic() override;

  void DisabledInit() override;
  void DisabledPeriodic() override;


 private:
  Lights lights{};
  Feedback feedback{};
  ControlPanel controlPanel{};
  Hang hang{};
  Drive drive{&lights};
  GamePiece gamePiece{};
  Log log{"/c/log.csv"};

  Autonomous autonomous{&drive, &gamePiece};

  Controls controls{&drive, &gamePiece, &hang, &controlPanel};

  frc::Timer loopTimer{};

  void processLights();
};
